# CraftPresence

## [v2.0.0](https://github.com/CDAGaming/CraftPresence-Wow-Edition/tree/v2.0.0) (2022-05-01)
[Full Changelog](https://github.com/CDAGaming/CraftPresence-Wow-Edition/compare/v1.9.7...v2.0.0) [Previous Releases](https://github.com/CDAGaming/CraftPresence-Wow-Edition/releases)

- Merge branch 'next'  
- [Hotfix] Fixed GUI errors relating to TexCoord OOB errors  
- [Change] Multi-Commit (See Details)  
    - Added a modify flag to Config Migrations, as well as an `optionalMigrations` setting to the extras menu. When `optionalMigrations` is enabled, it will allow the migration layers to be able to reset config values if needed (This is mainly for applying new default settings, that normally are not applied due to it modifying custom data, hence why this is an opt-in system). When the option is disabled but optional migrations are available, a message will be printed to state as such.  
    - Added a `migrate` sub-argument to the `/cp config` command to allow a forced config migration (As in it'll re-run the latest applicable migration layer, which is more useful to Beta users then anything else).  
    For Beta Users: Per-Beta default changes (Such as the stateCallback changes in between betas), will not be added to the optional Migrations list, primarily since the migration layers are designed for releases and migrating between releases. Beta users will have to use `/cp reset` accordingly to apply new defaults not listed as optional migrations.  
- [Fix] Added Support in `player\_alliance` for TBC and Vanilla Wow Clients  
- [Fix] Fixed Zereth Mortis Support for `player\_alliance`  
    - Turns out, Zereth Mortis is a different continent, and thus was never supported until now.  
- [Refactor] Misc. Cleanups  
    - Renamed `value` parameter to `data` for `ShouldProcessData` (Also replaced redundant logic in `AssertRenderData` with `ShouldProcessData`)  
    - Removed the `10000` limiters from the default config. If versions below Wow 1.12.1 break, let me know and the compatibility layers will be adjusted as needed  
- [Refactor] Cleanup Legacy Code from `GetUnitStatus`  
    - The reason setting for `CHAT\_MSG\_SYSTEM` events will now properly fallback to the default AFK and DND messages. Previously, this logic was done after the label processing in `GetUnitStatus`.  
- [Change] Added `online` as a Player Prefix  
    - By default, doesn't show anything if active/inactive, but can be configured to heart's desire.  
    - The fallback value for status has been changed to "Unknown" as well  
- [Change] Adjusted the default Delay Settings to allow for quicker events  
    - Callback Delay now defaults to 1 second instead of 2.  
    - The minimum delay allowed for frame clearing is now 3 instead of 5 (The old minimum is now the new default).  
    - The maximum callback delay allowed is now 5 rather then 30 (Seriously, in what world is sending an event 30 seconds after useful for an addon meant to show this quickly?!)  
- [Change] Bumped Script to v1.5.3  
    Notes:  
     - Fixed an issue where, if a malformed client ID is read, it will continue to try and read that same malformed ID (Causing log spam and requiring the user to restart the script). To avoid this, the script will now discard the event and the rpc object and relaunch the loop after `refresh\_rate` has passed.  
     - Adjusted the ending portion of the script loop to use `scan\_rate` instead of `refresh\_rate` (As a result, `scan\_rate` has been increased to every 3 seconds instead of every second)  
- [Change] Adjusted the tooltips for the Delay settings to be more clear  
- [Change] Mark Range Values of 0 and below as unsafe  
    - Further research into testing quicker timings for the Rich Presence, have yielded that specifically a Callback Delay of 0 will not give the wow api enough time to update, causing desync rich presence states. A warning will now be shown when the value is being set to ensure players are aware of this, as not all parts of the Rich Presence can desync, just some portions.  
- [Refactor] Added `PrintWarningMessage` for some small cleanups  
- [Hotfix] Fixed a regression in Labels from Beta 3  
    - Replaces the or conditional with GetOrDefault. Those effected or have already used Beta 3 should reset their labels portion of the config to ensure validity.  
- [Change] Removed Protected Data limiter on placeholders  
    - Since June of 2021, a limiter was put into place to throw a conflict error if you tried to overwrite placeholders, claiming they were protected data. As there are no conflicts since the v1.7.0 dynamic transition, this limiter was able to be safely removed. (It will still require the `create:modify` flag, to ensure the user actually wants to replace data.)  
- [Change] Added commands for `/cp labels`  
    - `/cp labels` has 3 sub-commands `create`, `remove`, and `list`. Creation and Removal of Lists are 1:1 to how placeholder creation works, and Listing labels will show the name of the label as well as what it would look like if the state was active.  
- [Change] Added `suffix` support for Placeholders  
    - The migration layer will copy your current prefix for each placeholder into the new suffix field, so old data is preserved.  
- [Change] Added `stateCallback` for Labels  
    - Bumped Schema version to 4.1 to allow porting the conditionals from `GetUnitStatus` to the data-driven format. `stateCallbacks` have been added to be able to configure and dictate when a state should be considered active or inactive.  
    - [Refactor] `GetUnitData` will now return an empty table instead of nil if the Unit specified does not have any data associated with the addon.  
    - [Refactor] `GetUnitStatus#unitData` will now fallback to `cachedUnitData` instead of an empty table (It will fallback to an empty table still, but only if there is no cached information)  
- [Refactor] Debugging Cleanup before deployment  
- [Change] Multi-Commit (See Details)  
    - [Fix] Re-allocate the Button and Label Parse logic in `SyncDynamicData` to address issues of Lag Spikes in Beta 1. Performance should now be on par with v1.9.x  
    - [Fix] Resolved a regression in Beta 1 where Placeholders were not correctly displaying with Buttons and Labels  
- [Change] Finished Initial Compatibility work for 1.12.1 UIs  
    - Minor cosmetic issues may still exist, which will be patched in future betas.  
    - Originally these 1.12.1 adjustments would have been in v1.9.x, though given their significance, were moved to the v2.0 pipeline to allow ample testing  
- [Change] Continued Work on 1.12.1 UIs  
- [Fix] Ensure type sanity for the validCallback in button options  
    - Prevents an incorrect type crash  
- [Change] Ensure Legacy UIs display at the same size as the Interface UI  
- [Change] Further work towards 1.12.1 UI Support  
- [Change] Begin work adding ConfigUI Support for < 2.0 Clients  
    - At this time, the GUI works, but refuses to open in some circumstances, so a Beta is being held off until I can figure it out.  
- [Fix] Misc. Fixes for Config Migrations  
- [Change] Added Translations for new config values  
- Merge branch 'master' into next  
- Merge branch 'master' into next  
- [Change] Begin v2.0 Development  
    - Added the ability for Labels and Buttons to use Custom Lua  
    - Schema has been increased from 3 to 4 to convert config data  
